KLineEdit class Reference (kdeui Library)

| # kdeui Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KLineEdit Class Reference

An enhanced QLineEdit widget for inputting text. An enhanced single line input widget. More...

`#include <klineedit.h>`

Inheritance diagram for KLineEdit:

[legend]
Collaboration diagram for KLineEdit:

[legend]
List of all members.

## Public Slots
virtual void | setReadOnly (bool)
| Re-implemented for internal reasons.
void | rotateText (KCompletionBase::KeyBindingType)
| Iterates through all possible matches of the completed text or the history list.
virtual void | setCompletedText (const QString &)
| See KCompletionBase::setCompletedText.
void | setCompletedItems (const QStringList &items)
| Sets `items` into the completion-box if completionMode() is CompletionPopup.
virtual void | clear ()
| Reimplemented to workaround a buggy QLineEdit::clear() (changing the clipboard to the text we just had in the lineedit).
void | setSqueezedText (const QString &text)
| Squeezes `text` into the line edit.
## Signals
void | completionBoxActivated (const QString &)
| Emitted whenever the completion box is activated.
void | returnPressed (const QString &)
| Emitted when the user presses the return key.
void | completion (const QString &)
| Emitted when the completion key is pressed.
void | substringCompletion (const QString &)
| Emitted when the shortcut for substring completion is pressed.
void | textRotation (KCompletionBase::KeyBindingType)
| Emitted when the text rotation key-bindings are pressed.
void | completionModeChanged (KGlobalSettings::Completion)
| Emitted when the user changed the completion mode by using the popupmenu.
void | aboutToShowContextMenu (QPopupMenu *)
| Emitted before the context menu is displayed.
## Public Member Functions
| KLineEdit (const QString &string, QWidget *parent, const char *name=0)
| Constructs a KLineEdit object with a default text, a parent, and a name.
| KLineEdit (QWidget *parent=0, const char *name=0)
| Constructs a KLineEdit object with a parent and a name.
virtual | ~KLineEdit ()
| Destructor.
void | setURL (const KURL &url)
| Sets `url` into the lineedit.
void | cursorAtEnd ()
| Puts the text cursor at the end of the string.
virtual void | setCompletionMode (KGlobalSettings::Completion mode)
| Re-implemented from KCompletionBase for internal reasons.
virtual void | setContextMenuEnabled (bool showMenu)
| Enables/disables the popup (context) menu.
bool | isContextMenuEnabled () const
| Returns `true` when the context menu is enabled.
void | setURLDropsEnabled (bool enable)
| Enables/Disables handling of URL drops.
bool | isURLDropsEnabled () const
| Returns `true` when decoded URL drops are enabled.
void | setTrapReturnKey (bool trap)
| By default, KLineEdit recognizes `Key_Return` and `Key_Enter` and emits the returnPressed() signals, but it also lets the event pass, for example causing a dialog's default-button to be called.
bool | trapReturnKey () const
virtual bool | eventFilter (QObject *, QEvent *)
| Re-implemented for internal reasons.
KCompletionBox * | completionBox (bool create=true)
virtual void | setCompletionObject (KCompletion *, bool hsig=true)
| Reimplemented for internal reasons, the API is not affected.
virtual void | copy () const
| Reimplemented for internal reasons, the API is not affected.
## Protected Slots
virtual void | makeCompletion (const QString &)
| Completes the remaining text with a matching one from a given list.
void | slotAboutToShow ()
| This class or method is obsolete, it is provided for compatibility only..
void | slotCancelled ()
| This class or method is obsolete, it is provided for compatibility only..
## Protected Member Functions
virtual void | resizeEvent (QResizeEvent *)
| Re-implemented for internal reasons.
virtual void | keyPressEvent (QKeyEvent *)
| Re-implemented for internal reasons.
virtual void | mousePressEvent (QMouseEvent *)
| Re-implemented for internal reasons.
virtual void | mouseDoubleClickEvent (QMouseEvent *)
| Re-implemented for internal reasons.
virtual QPopupMenu * | createPopupMenu ()
| Re-implemented for internal reasons.
virtual void | dropEvent (QDropEvent *)
| Re-implemented to handle URI drops.
virtual void | setCompletedText (const QString &, bool)
virtual void | create (WId=0, bool initializeWindow=true, bool destroyOldWindow=true)
| Reimplemented for internal reasons, the API is not affected.
virtual void | virtual_hook (int id, void *data)
## Friends
class | KComboBox

## Detailed Description

An enhanced QLineEdit widget for inputting text. An enhanced single line input widget.

Detail

This widget inherits from QLineEdit and implements the following additional functionalities: a completion object that provides both automatic and manual text completion as well as multiple match iteration features, configurable key-bindings to activate these features and a popup-menu item that can be used to allow the user to set text completion modes on the fly based on their preference.

To support these new features KLineEdit also emits a few more additional signals. These are: completion( const QString& ), textRotation( KeyBindingType ), and returnPressed( const QString& ). The completion signal can be connected to a slot that will assist the user in filling out the remaining text. The text rotation signal is intended to be used to iterate through the list of all possible matches whenever there is more than one match for the entered text. The `returnPressed( const QString& )` signals are the same as QLineEdit's except it provides the current text in the widget as its argument whenever appropriate.

This widget by default creates a completion object when you invoke the completionObject( bool ) member function for the first time or use setCompletionObject( KCompletion*, bool ) to assign your own completion object. Additionally, to make this widget more functional, KLineEdit will by default handle the text rotation and completion events internally when a completion object is created through either one of the methods mentioned above. If you do not need this functionality, simply use KCompletionBase::setHandleSignals( bool ) or set the boolean parameter in the above functions to FALSE.

The default key-bindings for completion and rotation is determined from the global settings in KStdAccel. These values, however, can be overriden locally by invoking KCompletionBase::setKeyBinding(). The values can easily be reverted back to the default setting, by simply calling useGlobalSettings(). An alternate method would be to default individual key-bindings by usning setKeyBinding() with the default second argument.

NOTE that if the `EchoMode` for this widget is set to something other than `QLineEdit::Normal`, the completion mode will always be defaulted to KGlobalSettings::CompletionNone. This is done purposefully to guard against protected entries such as passwords being cached in KCompletion's list. Hence, if the `EchoMode` is not QLineEdit::Normal, the completion mode is automatically disabled.

Usage

To enable the basic completion feature :

     KLineEdit *edit = new KLineEdit( this, "mywidget" );
     KCompletion *comp = edit->completionObject();
     // Connect to the return pressed signal - optional
     connect(edit,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&));

To use a customized completion objects or your own completion object :

     KLineEdit *edit = new KLineEdit( this,"mywidget" );
     KURLCompletion *comp = new KURLCompletion();
     edit->setCompletionObject( comp );
     // Connect to the return pressed signal - optional
     connect(edit,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&));

Note that you have to either delete the allocated completion object when you don't need it anymore, or call setAutoDeleteCompletionObject( true );

Miscellaneous function calls :

     // Tell the widget not to handle completion and
     // iteration internally.
     edit->setHandleSignals( false );
     // Set your own completion key for manual completions.
     edit->setKeyBinding( KCompletionBase::TextCompletion, Qt::End );
     // Hide the context (popup) menu
     edit->setContextMenuEnabled( false );
     // Temporarly disable signal emitions
     // (both completion & iteration signals)
     edit->disableSignals();
     // Default the key-bindings to system settings.
     edit->useGlobalKeyBindings();

Author:
  Dawit Alemayehu <adawit@kde.org>

Definition at line 136 of file klineedit.h.

## Constructor & Destructor Documentation

KLineEdit::KLineEdit | ( | const QString & | string,
|  | QWidget * | parent,
|  | const char * | name = 0
| ) |

  | Constructs a KLineEdit object with a default text, a parent, and a name. Parameters:
  string | Text to be shown in the edit widget.
  parent | The parent object of this widget.
  name | the name of this widget
Definition at line 71 of file klineedit.cpp. References KStdAccel::name().

KLineEdit::KLineEdit | ( | QWidget * | parent = 0,
|  | const char * | name = 0
| ) |

  | Constructs a KLineEdit object with a parent and a name. Parameters:
  string | Text to be shown in the edit widget.
  parent | The parent object of this widget.
  name | The name of this widget.
Definition at line 77 of file klineedit.cpp. References KStdAccel::name().

KLineEdit::~KLineEdit | ( |  | ) | `[virtual]`

| Destructor. Definition at line 83 of file klineedit.cpp.

## Member Function Documentation

void KLineEdit::setURL | ( | const KURL & | url | ) |

| Sets `url` into the lineedit. It uses KURL::prettyURL() so that the url is properly decoded for displaying. Definition at line 738 of file klineedit.cpp. References KURL::prettyURL(), and QLineEdit::setText().

void KLineEdit::cursorAtEnd | ( |  | ) | `[inline]`

| Puts the text cursor at the end of the string. This method is deprecated. Use QLineEdit::end() instead. This class or method is obsolete, it is provided for compatibility only. QLineEdit::end() Definition at line 185 of file klineedit.h. References QLineEdit::end().

void KLineEdit::setCompletionMode | ( | KGlobalSettings::Completion | mode | ) | `[virtual]`

| Re-implemented from KCompletionBase for internal reasons. This function is re-implemented in order to make sure that the EchoMode is acceptable before we set the completion mode. See KCompletionBase::setCompletionMode Reimplemented from KCompletionBase. Definition at line 100 of file klineedit.cpp. References KGlobalSettings::Completion, KCompletionBase::completionMode(), KGlobalSettings::CompletionNone, KGlobalSettings::CompletionPopup, QLineEdit::echoMode(), and KCompletionBase::setCompletionMode().

virtual void KLineEdit::setContextMenuEnabled | ( | bool | showMenu | ) | `[inline, virtual]`

  | Enables/disables the popup (context) menu. Note that when this function is invoked with its argument set to `true`, then both the context menu and the completion menu item are enabled. If you do not want to the completion item to be visible simply invoke hideModechanger() right after calling this method. Also by default, the context menu is automatically created if this widget is editable. Thus you need to call this function with the argument set to false if you do not want this behaviour. Parameters:
  showMenu | If `true`, show the context menu.
Definition at line 211 of file klineedit.h.

bool KLineEdit::isContextMenuEnabled | ( |  | ) | const`[inline]`

| Returns `true` when the context menu is enabled. Definition at line 216 of file klineedit.h.

void KLineEdit::setURLDropsEnabled | ( | bool | enable | ) |

  | Enables/Disables handling of URL drops. If enabled and the user drops an URL, the decoded URL will be inserted. Otherwise the default behaviour of QLineEdit is used, which inserts the encoded URL. Parameters:
  enable | If `true`, insert decoded URLs
Definition at line 718 of file klineedit.cpp.

bool KLineEdit::isURLDropsEnabled | ( |  | ) | const

| Returns `true` when decoded URL drops are enabled. Definition at line 723 of file klineedit.cpp.

void KLineEdit::setTrapReturnKey | ( | bool | trap | ) |

| By default, KLineEdit recognizes `Key_Return` and `Key_Enter` and emits the returnPressed() signals, but it also lets the event pass, for example causing a dialog's default-button to be called. Call this method with `trap` = `true` to make `KLineEdit` stop these events. The signals will still be emitted of course. See also: trapReturnKey() Definition at line 728 of file klineedit.cpp.

bool KLineEdit::trapReturnKey | ( |  | ) | const

| Returns: `true` if keyevents of `Key_Return` or `Key_Enter` will be stopped or if they will be propagated. See also: setTrapReturnKey () Definition at line 733 of file klineedit.cpp.

bool KLineEdit::eventFilter | ( | QObject * | ,
|  | QEvent * |
| ) | `[virtual]`

| Re-implemented for internal reasons. API not affected. Definition at line 676 of file klineedit.cpp. References QKeyEvent::accept(), KCursor::autoHideEventFilter(), QLineEdit::displayText(), QKeyEvent::key(), QLineEdit::returnPressed(), QKeyEvent::state(), and QEvent::type().

KCompletionBox * KLineEdit::completionBox | ( | bool | create = true | ) |

  | Returns: the completion-box, that is used in completion mode KGlobalSettings::CompletionPopup. This method will create a completion-box if none is there, yet. Parameters:
  create | Set this to false if you don't want the box to be created i.e. to test if it is available.
Definition at line 835 of file klineedit.cpp. References KStdAction::create().

void KLineEdit::setCompletionObject | ( | KCompletion * | ,
|  | bool | hsig = true
| ) | `[virtual]`

| Reimplemented for internal reasons, the API is not affected. Reimplemented from KCompletionBase. Definition at line 843 of file klineedit.cpp. References KCompletionBase::compObj(), KCompletionBase::handleSignals(), setCompletedItems(), and KCompletionBase::setCompletionObject().

void KLineEdit::copy | ( |  | ) | const`[virtual]`

| Reimplemented for internal reasons, the API is not affected. Reimplemented from QLineEdit. Definition at line 226 of file klineedit.cpp. References QApplication::clipboard(), QLineEdit::copy(), KStdAccel::end(), QLineEdit::end(), QString::mid(), and QLineEdit::selectionChanged(). Referenced by keyPressEvent().

void KLineEdit::completionBoxActivated | ( | const QString & |  | ) | `[signal]`

| Emitted whenever the completion box is activated. Since: 3.1

void KLineEdit::returnPressed | ( | const QString & |  | ) | `[signal]`

| Emitted when the user presses the return key. The argument is the current text. Note that this signal is not emitted if the widget's `EchoMode` is set to QLineEdit::EchoMode.

void KLineEdit::completion | ( | const QString & |  | ) | `[signal]`

| Emitted when the completion key is pressed. Please note that this signal is not emitted if the completion mode is set to `CompletionNone` or `EchoMode` is normal. Referenced by keyPressEvent().

void KLineEdit::substringCompletion | ( | const QString & |  | ) | `[signal]`

| Emitted when the shortcut for substring completion is pressed. Referenced by keyPressEvent().

void KLineEdit::textRotation | ( | KCompletionBase::KeyBindingType |  | ) | `[signal]`

| Emitted when the text rotation key-bindings are pressed. The argument indicates which key-binding was pressed. In KLineEdit's case this can be either one of two values: PrevCompletionMatch or NextCompletionMatch. See KCompletionBase::setKeyBinding for details. Note that this signal is not emitted if the completion mode is set to `KGlobalSettings::CompletionNone` or `echoMode()` is not normal. Referenced by keyPressEvent().

void KLineEdit::completionModeChanged | ( | KGlobalSettings::Completion |  | ) | `[signal]`

| Emitted when the user changed the completion mode by using the popupmenu.

void KLineEdit::aboutToShowContextMenu | ( | QPopupMenu * |  | ) | `[signal]`

  | Emitted before the context menu is displayed. The signal allows you to add your own entries into the the context menu that is created on demand. NOTE: Do not store the pointer to the QPopupMenu provided through since it is created and deleted on demand. Parameters:
  the | context menu about to be displayed
Referenced by createPopupMenu().

void KLineEdit::setReadOnly | ( | bool |  | ) | `[virtual, slot]`

| Re-implemented for internal reasons. API not changed. Reimplemented from QLineEdit. Definition at line 183 of file klineedit.cpp. References QLineEdit::isReadOnly(), QLineEdit::setReadOnly(), and QLineEdit::setText().

void KLineEdit::rotateText | ( | KCompletionBase::KeyBindingType |  | ) | `[slot]`

  | Iterates through all possible matches of the completed text or the history list. This function simply iterates over all possible matches in case multimple matches are found as a result of a text completion request. It will have no effect if only a single match is found. Parameters:
  type | The key-binding invoked.
Definition at line 137 of file klineedit.cpp. References KCompletionBase::compObj(), QLineEdit::displayText(), QLineEdit::hasSelectedText(), QString::isNull(), KCompletionBase::NextCompletionMatch, KCompletion::nextMatch(), KCompletionBase::PrevCompletionMatch, KCompletion::previousMatch(), and setCompletedText(). Referenced by keyPressEvent().

void KLineEdit::setCompletedText | ( | const QString & |  | ) | `[virtual, slot]`

| See KCompletionBase::setCompletedText. Implements KCompletionBase. Definition at line 128 of file klineedit.cpp. References KGlobalSettings::Completion, KGlobalSettings::CompletionAuto, KGlobalSettings::CompletionMan, KCompletionBase::completionMode(), and KGlobalSettings::CompletionPopup. Referenced by makeCompletion(), and rotateText().

void KLineEdit::setCompletedItems | ( | const QStringList & | items | ) | `[virtual, slot]`

| Sets `items` into the completion-box if completionMode() is CompletionPopup. The popup will be shown immediately. Implements KCompletionBase. Definition at line 814 of file klineedit.cpp. References QString::isEmpty(), and QLineEdit::text(). Referenced by keyPressEvent(), makeCompletion(), and setCompletionObject().

void KLineEdit::clear | ( |  | ) | `[virtual, slot]`

| Reimplemented to workaround a buggy QLineEdit::clear() (changing the clipboard to the text we just had in the lineedit). Reimplemented from QLineEdit. Definition at line 864 of file klineedit.cpp. References QLineEdit::setText(). Referenced by KEditListBox::clear().

void KLineEdit::setSqueezedText | ( | const QString & | text | ) | `[slot]`

| Squeezes `text` into the line edit. This can only be used with read-only line-edits. Since: 3.1 Definition at line 207 of file klineedit.cpp. References QLineEdit::isReadOnly(), resizeEvent(), and QLineEdit::setText().

void KLineEdit::makeCompletion | ( | const QString & |  | ) | `[protected, virtual, slot]`

| Completes the remaining text with a matching one from a given list. Definition at line 152 of file klineedit.cpp. References KCompletion::allMatches(), KGlobalSettings::Completion, KCompletionBase::completionMode(), KGlobalSettings::CompletionPopup, KCompletionBase::compObj(), QString::isNull(), KCompletion::makeCompletion(), setCompletedItems(), and setCompletedText(). Referenced by keyPressEvent().

void KLineEdit::slotAboutToShow | ( |  | ) | `[inline, protected, slot]`

| This class or method is obsolete, it is provided for compatibility only.. Will be removed in the next major release! Definition at line 397 of file klineedit.h.

void KLineEdit::slotCancelled | ( |  | ) | `[inline, protected, slot]`

| This class or method is obsolete, it is provided for compatibility only.. Will be removed in the next major release! Definition at line 402 of file klineedit.h.

void KLineEdit::resizeEvent | ( | QResizeEvent * |  | ) | `[protected, virtual]`

| Re-implemented for internal reasons. API not affected. See QLineEdit::resizeEvent(). Definition at line 257 of file klineedit.cpp. References QToolTip::add(), QToolTip::hide(), QString::left(), QString::length(), QToolTip::remove(), QString::right(), QLineEdit::setCursorPosition(), QLineEdit::setText(), and QFontMetrics::width(). Referenced by setSqueezedText().

void KLineEdit::keyPressEvent | ( | QKeyEvent * |  | ) | `[protected, virtual]`

| Re-implemented for internal reasons. API not affected. See QLineEdit::keyPressEvent(). Reimplemented from QLineEdit. Reimplemented in KListViewLineEdit, and KRestrictedLine. Definition at line 320 of file klineedit.cpp. References QKeyEvent::accept(), QApplication::clipboard(), completion(), KGlobalSettings::Completion, KGlobalSettings::CompletionAuto, KGlobalSettings::CompletionMan, KCompletionBase::completionMode(), KGlobalSettings::CompletionNone, KGlobalSettings::CompletionPopup, KGlobalSettings::CompletionShell, KCompletionBase::compObj(), copy(), KStdAccel::copy(), QLineEdit::cursorPosition(), QLineEdit::cursorWordBackward(), QLineEdit::cursorWordForward(), KStdAccel::cut(), QLineEdit::cut(), QLineEdit::del(), KStdAccel::deleteWordBack(), KStdAccel::deleteWordForward(), QLineEdit::deselect(), QLineEdit::echoMode(), KCompletionBase::emitSignals(), KCompletionBase::getKeyBindings(), KCompletionBase::handleSignals(), QLineEdit::hasSelectedText(), QLineEdit::insert(), QString::isEmpty(), QKeyEvent::key(), KStdAccel::key(), KCompletionBase::KeyBindingMap, QLineEdit::keyPressEvent(), QString::length(), makeCompletion(), KCompletionBase::NextCompletionMatch, QLineEdit::paste(), KStdAccel::paste(), KCompletionBase::PrevCompletionMatch, QLineEdit::redo(), KStdAccel::redo(), rotateText(), setCompletedItems(), KStdAccel::shortcut(), QKeyEvent::state(), substringCompletion(), KCompletionBase::SubstringCompletion, QLineEdit::text(), QKeyEvent::text(), KCompletionBase::TextCompletion, textRotation(), QLineEdit::undo(), KStdAccel::undo(), and QString::unicode(). Referenced by KListViewLineEdit::keyPressEvent().

void KLineEdit::mousePressEvent | ( | QMouseEvent * |  | ) | `[protected, virtual]`

| Re-implemented for internal reasons. API not affected. See QLineEdit::mousePressEvent(). Definition at line 546 of file klineedit.cpp. References QMouseEvent::button(), and QLineEdit::selectAll().

void KLineEdit::mouseDoubleClickEvent | ( | QMouseEvent * |  | ) | `[protected, virtual]`

| Re-implemented for internal reasons. API not affected. See QWidget::mouseDoubleClickEvent(). Definition at line 535 of file klineedit.cpp. References QMouseEvent::button(), QApplication::doubleClickInterval(), and QTimer::singleShot().

QPopupMenu * KLineEdit::createPopupMenu | ( |  | ) | `[protected, virtual]`

| Re-implemented for internal reasons. API not affected. See QLineEdit::createPopupMenu(). Reimplemented from QLineEdit. Definition at line 561 of file klineedit.cpp. References aboutToShowContextMenu(), KGlobalSettings::Completion, KGlobalSettings::CompletionAuto, KGlobalSettings::CompletionMan, KGlobalSettings::completionMode(), KCompletionBase::completionMode(), KGlobalSettings::CompletionNone, KGlobalSettings::CompletionPopup, KGlobalSettings::CompletionShell, KCompletionBase::compObj(), QLineEdit::createPopupMenu(), QPopupMenu::insertItem(), QPopupMenu::insertSeparator(), QLineEdit::isReadOnly(), QPopupMenu::setAccel(), and QPopupMenu::setItemChecked().

void KLineEdit::dropEvent | ( | QDropEvent * |  | ) | `[protected, virtual]`

| Re-implemented to handle URI drops. See QLineEdit::dropEvent(). Definition at line 653 of file klineedit.cpp. References QDropEvent::accept(), QValueList< KURL >::begin(), QValueList< KURL >::ConstIterator(), KURLDrag::decode(), QValueList< KURL >::end(), QString::isEmpty(), QString::length(), and QLineEdit::text().

void KLineEdit::create | ( | WId | = 0,
|  | bool | initializeWindow = true,
|  | bool | destroyOldWindow = true
| ) | `[protected, virtual]`

| Reimplemented for internal reasons, the API is not affected. Definition at line 858 of file klineedit.cpp. References KCursor::setAutoHideCursor().

The documentation for this class was generated from the following files:

- klineedit.h
- klineedit.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:01:58 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001